import _Object$keys from '@babel/runtime-corejs3/core-js-stable/object/keys';
import _mapInstanceProperty from '@babel/runtime-corejs3/core-js-stable/instance/map';
import _concatInstanceProperty from '@babel/runtime-corejs3/core-js-stable/instance/concat';

var _require = require('@babel/helper-module-imports'),
  addDefault = _require.addDefault,
  addSideEffect = _require.addSideEffect;
function main () {
  // console.log(arguments)
  var pathList = {};
  return {
    // 每个文件都会走一遍visitor
    visitor: {
      /**
       * visitor的Program里的enter可以理解为，会在visitor里的所有操作执行前，执行一次enter；
       * 而exit可以理解为，在visitor里的所有操作执行完了后，会执行一次exit
       */
      Program: {
        enter: function enter(path, state) {
          console.log('enter', state.filename);
        },
        exit: function exit(path, state) {
          console.log('exit', state.filename);
          _Object$keys(pathList).forEach(function (key) {
            !pathList[key].removed && pathList[key].remove();
          });
        }
      },
      /**
       * 引入模块的时候会执行这个函数，如import { bbb } from 'aaa'
       */
      ImportDeclaration: function ImportDeclaration(path, state) {
        var node = path.node;
        if (!node) return;
        var value = node.source.value; // 这个value是aaa
        var libraryName = state.opts.libraryName;
        if (value === libraryName) {
          node.specifiers.forEach(function (spec) {
            pathList[spec.local.name] = path;
          });
        }
      },
      /**
       * 调用表达式的时候会执行这个函数，如：console.log(),这里调用了console.log这个方法
       */
      CallExpression: function CallExpression(path, state) {
        var _context;
        // state.opts:能获取babel.config.js里传进来的参数：
        // state.cwd:node进程工作目录？
        // state.file:当前匹配的文件
        // state.filename:当前匹配的文件路径，如：'/Users/huangshuisheng/Desktop/hss/github/webpack-multi-static/src/page/index.ts'
        var node = path.node;
        var file = path && path.hub && path.hub.file || state && state.file;
        var _state$opts = state.opts,
          libraryName = _state$opts.libraryName,
          libraryDirectory = _state$opts.libraryDirectory,
          _state$opts$style = _state$opts.style,
          style = _state$opts$style === void 0 ? true : _state$opts$style;
        node.arguments = _mapInstanceProperty(_context = node.arguments).call(_context, function (arg) {
          var argName = arg.name;
          var res = {};
          _Object$keys(pathList).forEach(function (item) {
            if (item === argName) {
              var _context2, _context3;
              res = addDefault(file.path, _concatInstanceProperty(_context2 = _concatInstanceProperty(_context3 = "".concat(libraryName, "/")).call(_context3, libraryDirectory, "/")).call(_context2, item), {
                nameHint: item
              });
              if (style === true) {
                var _context4, _context5;
                addSideEffect(file.path, _concatInstanceProperty(_context4 = _concatInstanceProperty(_context5 = "".concat(libraryName, "/")).call(_context5, libraryDirectory, "/")).call(_context4, item, "/style/index.js"));
              } else if (style === 'css') {
                var _context6, _context7;
                addSideEffect(file.path, _concatInstanceProperty(_context6 = _concatInstanceProperty(_context7 = "".concat(libraryName, "/")).call(_context7, libraryDirectory, "/")).call(_context6, item, "/style/css.js"));
              }
            }
          });
          if (_Object$keys(res).length) {
            return res;
          }
          return arg;
        });
      }
    }
  };
}

export { main as default };
